function y = MNhessian(x)
% Purpose:  This code computes the Magnus-Neudecker Hessian matrix. 
%           Given a tridimensional (n1 x n2 x n3) Hessian array x, 
%           it computes appropriate permutations to reshape it into the two-dimensional 
%           (n1*n2 x n3) MN Hessian matrix y 
% Input:    matrix x 
% Output:   matrix y
% 
% This code is the same as hessian.m, by Stephanie Schmitt-Groh and Martin Uribe
% 

[n1,n2,n3]=size(x);
y=reshape(permute(x,[ 2 1 3]), n1*n2, n3);

