function [rr,ll] = gensyl(aa,bb,cc,dd,ee,ff)

%
% Solving a generalized Sylvester equation using LAPACK
% routine ztgsyl
%
% AR-LB=C
% DR-LE=F
%

m = size(aa,1);
n = size(bb,1);

% Putting (aa,dd) and (bb,ee) into generalized Schur form

[aa1,dd1,pp,qq] = qz(aa,dd);
pp=pp';

%aa1 = pp'*aa*qq
%dd1 = pp'*aa*qq

[bb1,ee1,uu,vv] = qz(bb,ee);
uu = uu';

%bb1 = uu'*bb*vv
%ee1 = uu'*aa*vv

cc1 = pp'*cc*vv;
ff1 = pp'*ff*vv;

trans = 'N';
ijob = 0;
lda = m;
ldb = n;
ldc = m;
ldd = m;
lde = n;
ldf = m;
dif = 0.0;
scale = 0.0;
work = 0.0*ones(2*m*n,1);
lwork = 2*m*n;
iwork = zeros(m+n+2,1);
info = 0;

output = lapack('ztgsyl',trans,ijob,m,n,aa1,lda,bb1,ldb,cc1,...
                         ldc,dd1,ldd,ee1,lde,ff1,ldf,dif,scale,...
                         work,lwork,iwork,info);

rr1 = output{9};
ll1 = output{15};

rr = real(qq*rr1*vv');
ll = real(pp*ll1*uu');
