function y = tracem(x)
% function  y = tracem(x) tracem operator
% 
% input:    x.  matrix of size (mn x n), such that
% 
%               x = [x1; x2; ... xm] 
% 
%               where each xi is (n x n)
% 
% output:   y.  vector of size (m x 1), such that element i is the trace of submatrix xi
% 
% Code written by Paul Klein 
% 

n = size(x,2);
m = size(x,1)/n;

y = zeros(m,1);

for i=1:m
   y(i)=trace(x((n*(i-1)+1):i*n,1:n));
end
